<?php

class Sitio extends CI_Controller
{

	private $resultados     = 30;

	public function __construct()
	{
		parent::__construct();

		$this->load->model('productsmodel');
		$this->load->model('settingsmodel');
		$this->load->model('statusmodel');
		$this->load->model('ofertasmodelo');
		//$this->statusmodel->checkUser();
		//var_dump($this->session->all_userdata());

		//$this->cart->destroy();
		//var_dump($this->cart->contents());
		//var_dump($this->statusmodel->checkUser());

	}

	public function index()
	{

		$this->functions->setUrlReferer();

		$this->load->model('slidermodel');

		$head = array(

			'title' 		=> $this->config->item('site_home_title') . ' | ' .$this->config->item('site_name'),
			'description' 	=> $this->config->item('site_description'),
		);

		$this->templates->head($head);
		$this->templates->header();
		//$this->templates->sidebar();

		$data = array(

			'destacados'	=> $this->productsmodel->important(12),
			'slider'		=> $this->slidermodel->get(true, 'slide'),
			'img'			=> $this->slidermodel->get(true, 'img'),
			'nuevos'		=> $this->productsmodel->get(0, 8, "id DESC", false, true, false),
			'ofertas'		=> $this->ofertasmodelo->get(0, 4, "fecha DESC")

		);

		$this->load->view('site/index', $data);

		$this->templates->footer();
	}

	public function index_2()
	{

		$this->functions->setUrlReferer();

		$this->load->model('slidermodel');

		$head = array(

			'title' 		=> $this->config->item('site_home_title') . ' | ' .$this->config->item('site_name'),
			'description' 	=> $this->config->item('site_description'),
		);

		$this->templates->head($head);
		$this->templates->header_2();
		//$this->templates->sidebar();

		$data = array(

			'destacados'	=> $this->productsmodel->important(12),
			'slider'		=> $this->slidermodel->get(true, 'slide'),
			'img'			=> $this->slidermodel->get(true, 'img'),
			'nuevos'		=> $this->productsmodel->get(0, 8, "id DESC", false, true, false),

		);

		$this->load->view('site/index', $data);

		$this->templates->footer();
	}

	public function ofertas()
	{
		$this->functions->setUrlReferer();

		$this->load->model('ofertasmodelo');

		$head = array(

			'title' 		=> 'Oferta del mes | ' .$this->config->item('site_name'),
			'description' 	=> '',
		);

		$this->templates->head($head);
		$this->templates->header();

		$data = array(

			'ofertas'		=> $this->ofertasmodelo->getActive(),
		);

		$this->load->view('site/oferta', $data);

		$this->templates->footer();
	}

	public function buscar()
	{

		$keyword = utf8_decode( $this->input->get('q', true) );
		$start   = intval( $this->input->post('s') );

		$productos = $this->productsmodel->buscar($keyword, $start, $this->resultados);

		$head = array(

			'title' 		=> 'Búsqueda de productos | '.$this->config->item('site_name'),
			'description' 	=> '',

		);

		$this->templates->head($head);
		$this->templates->header();

		$category = new stdClass();
		$category->name = "Búsqueda de productos";
		$category->description = "Resultados relacionados con la busqueda '" . $this->input->get('q'). "'";
		$category->id = false;
		$category->parent = false;

		$data = array(

			'products'		=> $productos,
			'breadcrumb'	=> $this->render->searchBreadcrumb(),
			'paginador'		=> false,
			'category'		=> $category,
			'categories'	=> $this->categoriesmodel->get(true),
			'childs'		=> false,

		);

		$this->load->view('site/product-list', $data);

		$this->templates->footer();

	}

	public function statics($s)
	{

		$path = '';

		if($this->session->userdata('site_lang') == 'english')
		{
			if( ! file_exists('./application/views/site/others/en/'.$s.'.php'))
			{
				show_404();
			}
			$path = 'en/';
		}
		else
		{
			if( ! file_exists('./application/views/site/others/'.$s.'.php'))
			{
				show_404();
			}
		}

		$this->functions->setUrlReferer();

		$titulo = str_replace("-", " ", $s);
		$titulo = ucfirst($titulo);

		$this->templates->head(array('title' => $titulo.' | '.$this->config->item('site_name'), 'slider' => true));
		$this->templates->header();

		$this->load->view('site/others/'.$path.$s);

		$this->templates->footer();
	}

	public function products($slug = 0, $order = false, $inicio = 0)
	{
		$category = false;

		if(!$order && $this->session->userdata('orden_actual') != '')
		{
			$orden = $this->session->userdata('orden_actual');
		}
		else
		{
			$orden = $this->orden_productos($order);
		}

		$this->session->set_userdata('orden_actual', $orden);

		if($slug)
		{
			$category = $this->categoriesmodel->single_slug($slug);

			if(!$category) show_404();

			$this->session->set_userdata('categoria_actual', $category->id);
		}
		else
		{
			$this->session->set_userdata('categoria_actual', false);
		}

		if(!$category)
		{
			$childs =  false;
			$childs_array = false;
			$childs_ids = false;
		}
		else
		{
			$childs_array 	= $this->categoriesmodel->getChilds($category->id, true);
			$childs_ids  	= $this->functions->categoryChildsIds($childs_array);
			$childs[]	    = $category->id;
		}

		if(!$slug)
		{
			$category = new stdClass();
			$category->name = "Todos los productos";
			$category->description = "Listado completo de todos los productos disponibles.";
			$category->id = false;
			$category->parent = false;
		}

		$this->functions->setUrlReferer();

		$this->templates->head(array('title' => $category->name.' | '.$this->config->item('site_name'), 'description' => $category->description ));
		$this->templates->header();

		$this->load->library('pagination');

		$path = 'productos/';

		$config = array(

            'base_url'      => base_url($path.$slug.'/'.$order),
            'total_rows'    => $this->productsmodel->count($childs, true),
            'per_page'      => $this->resultados,
            'uri_segment'   => 4,
            'full_tag_open' => '<div class="paginador">',
            'full_tag_close'=> '</div>'

        );

		$this->pagination->initialize($config);

		$data = array(

			'products'		=> $this->productsmodel->get($inicio, $this->resultados, $orden, $childs, true, false),
			'paginador'		=> $this->pagination->create_links(),
			'category'		=> $category,
			'categories'	=> $this->categoriesmodel->get(true),
			'breadcrumb'	=> $this->render->categoryBreadCrumb($category->id),
			'ordenador'		=> $this->functions->orderList($slug, $orden, $inicio),
			'childs'		=> $childs_array,
			'parents'       => $category->id ? $this->categoriesmodel->getParents($category->id) : false,
			'destacados'	=> $this->productsmodel->important()

		);

		$this->load->view('site/product-list', $data);

		$this->templates->footer();
	}

	public function product($id = false, $slug = false)
	{

		$product = $this->productsmodel->single($id);

		if( ! $product)
		{
			show_404();
		}

		$og 				= new stdClass();
		$og->title 			= $product->name;
		$og->url 			= $product->permalink;
		$og->img 			= base_url().$product->thumb;
		$og->site 			= $this->config->item('site_name');
		$og->description 	= false;

		$head = array(

			'title' 			=> $product->name.' | '.$this->config->item('site_name'),
			'description' 		=> false,
			'og' 				=> $og,

		);

		$this->templates->head($head);

		$this->templates->header();

		$data['producto'] 			= $product;
		$data['images']				= $this->imgmodel->get($product->id, true);
		
		$data['relevant']			= $this->productsmodel->relevant(8, $id);


		$this->load->view('site/single', $data);

		$this->templates->footer();
	}

	public function order($estado = 'carrito', $msj = false)
	{

		$this->load->model('usersmodel');
		$estados = array(

			'carrito',
			'facturacion',
			'metodos',
			'exito'
		);

		if(!in_array($estado, $estados))
		{
			show_404();
		}

		$data['cart_data'] = $this->functions->checkCartData();
		$data['status'] = 'pending';
		$data['cart']	= false;

		if($msj == 'exito')
		{
			$data['status'] = 'confirmed';
		}
		elseif($msj == 'error')
		{
			$data['status'] = 'error';
		}

		$data['breadcrumb'] = $this->functions->carritoBreadcrumb($estado);

		$this->templates->head(array('title' => 'Realizar Compra | ' . $this->config->item('site_name')) );
		$this->templates->header();

		if( $this->cart->total_items() > 0 )
		{
			$cart = array();
			foreach ($this->cart->contents() as $key => $items)
			{
				$variant =  $this->cartmodel->single($items['id']);

                $cart[$key] =  $this->productsmodel->single($variant->product);

				$cart[$key]->items 	= $items;
			}

			$data['cart'] = $cart;
			$this->load->view('site/'.$estado, $data);
		}
		else
		{
			$this->load->view('site/carrito_vacio', $data);
		}

		$this->templates->footer();
	}


	public function contact()
	{

		$data['mostrar'] = true;

		$this->functions->setUrlReferer();

		if( $this->form_validation->run('contact') )
		{

			$data_body = array(

				'nombre'		=> $this->input->post('name', true),
				'apellido'		=> $this->input->post('lastname', true),
				'email'			=> $this->input->post('email', true),
				'telefono'		=> $this->input->post('tel', true),
				'consulta'		=> $this->input->post('message', true),
			);

			$body = $this->load->view('emails/consulta', $data_body, true);

			$render = array(

				'footer'		=> false,
				'html'			=> $body,
				'titulo'		=> false,

			);

			$html = $this->load->view('email', $render, true);

			$data = array(

				'to' 		=> $this->config->item('email_to'),
				'reply_to'	=> $this->input->post('email', true),
				'subject'	=> 'Contacto vía web | '.$this->config->item('site_name'),
				'html'		=> $html

			);

			if( $this->functions->sendEmail($data) )
			{
				$data['mostrar'] = false;
			}
			else
			{
				$data['error'] = 'Ha ocurrido un error';
			}
		}
		else
		{
			$data['error'] = validation_errors();
		}

		$this->templates->head(array('title' => 'Contacto | ' . $this->config->item('site_name'), 'mapa' => true));
		$this->templates->header();

		$this->load->view('site/contact', $data);

		$this->templates->footer();
	}

	public function olvido()
	{
		$this->load->model('usersmodel');

		$this->session->set_userdata('referer', current_url() );

		$data['msj'] 		= false;
		$data['cambiado'] 	= false;

		if( isset($_POST['enviar']) )
		{
			$this->load->helper('string');
           	$token = random_string('md5', 32);

           	$user = $this->usersmodel->singleMail($this->input->post('user', true));

           	if( $user != false )
           	{
           		$datos['token'] 			= $token;
           		$datos['token_date']		= time();

           		if( $this->usersmodel->update($user->id, $datos) )
           		{
           			$link 			= base_url('token/'.$user->id.'/'.$token);
           			$html['html'] 	= '<p>Si usted ha solicitado el cambio de contrase&ntilde;a en su cuenta de '.$this->config->item('site_name').' por favor siga el siguiente enlace. De lo contrario ignore este e-mail, muchas gracias</p>';
           			$html['html']  .= '<br><a href="'.$link.'">'.$link.'</a>';

           			$html   = $this->load->view('email', $html, true);

           			$data = array(

           				'to' 			=> $user->mail,
           				'reply_to' 		=> false,
           				'subject'		=> 'Recuperar Clave - '.$this->config->item('site_name'),
           				'html'			=> $html,
           			);

           			$this->functions->sendEmail( $data );
           			$data['cambiado'] = true;
           			$data['msj'] = 'Le hemos enviado un e-mail a su cuenta con las instrucciones para cambiar su clave.';
           		}

           	}
           	else
           	{
           		$data['msj'] = 'El usuario ingresado no existe.';
           	}
		}
		$this->templates->head(array('title' => 'Recuperar clave | ' . $this->config->item('site_name')));
		$this->templates->header();
		$this->load->view('site/forgotten', $data);
		$this->templates->footer();
	}


	public function logout()
	{
		$this->statusmodel->logout();

		$this->cart->destroy();

		redirect( base_url() );
	}

	public function token($id = false, $token = false)
	{
		$this->load->model('usersmodel');

		if( !$token || !$id )
		{
			exit;
		}

		if(strlen($token) != 32)
		{
			exit;
		}

		$user = $this->usersmodel->single( $id );

		if( !$user )
		{
			exit;
		}

		if( $user->token != $token )
		{
			exit;
		}

		if( ( time() - $user->token_date ) > $this->config->item('token_limit') )
		{
			redirect(base_url(''));
		}

		$error = false;

		if( isset($_POST['enviar']) )
		{

			$data = array(

				'pass' 		=> md5($this->input->post('password', true)),
				'token'		=> ''
			);

			if( $this->usersmodel->update($id, $data) )
			{
				redirect( base_url() );
			}
		}

		$this->templates->head(array('title' => 'Recuperar clave | ' . $this->config->item('site_name') ));
		$this->templates->header();
		$this->load->view('site/change_pass');
		$this->templates->footer();
	}

	public function register($token = false, $id = false)
	{
		$this->load->model('usersmodel');

		$head = array(

			'title' 	=> 'Ingresa con tu cuenta | ' . $this->config->item('site_name'),
			'recaptcha' => true
		);

		$this->templates->head( $head );
		$this->templates->header();

		if( $token != false )
		{

			if( $this->usersmodel->checkToken($token, $id) )
			{
				$user = $this->usersmodel->single_tmp($id);
				$user->active = 1;
				$user->id = false;
				$this->usersmodel->add($user);
				$this->usersmodel->delete_tmp($id);

				$user_data 				= new stdClass;
				$user_data->id 			= $this->usersmodel->last();
				$user_data->name    	= $user->name;
				$user_data->lastname  	= $user->lastname;
				$user_data->mail 		= $user->mail;

				$this->statusmodel->setUserSession($user_data);

				redirect('');
			}
			else
			{
				$this->usersmodel->delete_tmp($id);
				$this->load->view('site/register_token_error');
			}

		}
		else
		{
			show_404();
		}

		$this->templates->footer();
	}

	private function orden_productos($orden = false)
	{
		$return = 'id_desc';

		switch ($orden)
		{
			case 'id_desc':
				$return = 'products.id DESC';
			break;

			case 'id_asc':
				$return = 'products.id ASC';
			break;

			case 'precio_asc':
				$return = 'product_price ASC';
			break;

			case 'precio_desc':
				$return = 'product_price DESC';
			break;

			default:
				$return = 'products.id DESC';
			break;
		}

		return $return;
	}


}
