<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Brands extends CI_Controller{

	private $tipo = "marcas";

	public function __construct()
	{
	   	parent::__construct();

	   	$this->load->model('settingsmodel');
	   	$this->load->model('statusmodel');
        $this->load->model('brandsmodel');
        $this->session->set_userdata('admin_menu', 'brands');

        if( ! $this->statusmodel->loggedAdmin())
        {
            redirect('admin');
            exit();
        }
    }

	public function listar()
	{
		$this->templates_admin->head();
		$this->templates_admin->header(array('title' => 'Lista de marcas'));
        $this->templates_admin->subMenu(array('nueva+' => 'marcas/nueva' ));

        $this->templates_admin->sidebar();

        $data['msj'] = "";
        $confirmar = false;

        $this->functions->checkbox('brandsmodel');

		$data[$this->tipo] 	= $this->brandsmodel->get();
		$data['tipo']		= $this->tipo;

        $this->load->view('admin/'.$this->tipo.'/list', $data);

		$this->templates_admin->footer();
	}

    public function nueva()
    {
        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Nueva categoria'));
        $data = array(  

                'tipo'          => $this->tipo,
                'added'         => false
            );
        
        if(isset($_POST['enviar']))
        {
            if($this->form_validation->run('brands'))
            {
                $array = array(

                    'id'            => null,
                    'name'          => $this->input->post('name'),
                    'link'          => $this->input->post('link'),
                    'active'        => 1
                );

                if($this->brandsmodel->add($array))
                {
                    $data['added'] = true;
                }
            }
        }

        $accion = $data['added'] ? 'volver' : 'cancelar';

        $this->templates_admin->subMenu(array($accion => 'marcas/listar' ));

        $this->templates_admin->sidebar();

        $this->load->view('admin/'.$this->tipo.'/nuevo', $data);
        
        $this->templates_admin->footer();
    }

    public function editar($id)
    {
        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Editar Marca'));

        $data = array(

                'tipo'          => $this->tipo,
                $this->tipo     => $this->brandsmodel->single($id)

                );
        
        if(isset($_POST['enviar']))
        {
            if($this->form_validation->run('brands'))
            {
                $array = array(

                    'name'          => $this->input->post('name'),
                    'link'          => $this->input->post('link'),
                    'active'        => $data[$this->tipo]->active
                );

                if($this->brandsmodel->update($id, $array))
                {
                    redirect('admin/marcas/listar');
                }
            }
        }

        $this->templates_admin->subMenu(array('cancelar' => '../listar' ));

        $this->templates_admin->sidebar();

        $this->load->view('admin/'.$this->tipo.'/edit', $data);
        
        $this->templates_admin->footer();
    }

 



}