<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Mensajes extends CI_Controller{

    private $tipo = "mensajes";
    private $ext_temp = false;

    public function __construct()
    {
        parent::__construct();

        $this->load->model('settingsmodel');
        $this->load->model('statusmodel');
        $this->load->model('messagesmodel');
        $this->load->library('upload');
        $this->session->set_userdata('admin_menu', 'mensajes');
        $this->ext_temp = false;
        if( ! $this->statusmodel->loggedAdmin())
        {
            redirect('admin');
            exit();
        }
        date_default_timezone_set('America/Montevideo');
    }

    public function listar()
    {
        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Lista de slides'));
        $this->templates_admin->subMenu(array('nuevo mensaje+' => 'mensajes/nuevo', 'Enviados' => 'mensajes/enviados' ));
        $this->templates_admin->sidebar();
        $data['msj'] = "";
        $confirmar = false;

        $this->functions->checkboxMsg();
        
        $data[$this->tipo]  = $this->messagesmodel->get();
        $data['tipo']       = $this->tipo;
        $this->load->view('admin/'.$this->tipo.'/list', $data);
        $this->templates_admin->footer();
    }


    public function enviados()
    {
        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Lista de slides'));
        $this->templates_admin->subMenu(array('Entrada' => 'mensajes/listar', 'nuevo mensaje+' => 'mensajes/nuevo' ));
        $this->templates_admin->sidebar();
        $data['msj'] = "";
        $confirmar = false;

        $this->functions->checkboxMsg();
        
        $data[$this->tipo]  = $this->messagesmodel->getSend();
        $data['tipo']       = $this->tipo;
        $this->load->view('admin/'.$this->tipo.'/send', $data);
        $this->templates_admin->footer();
    }

    public function nuevo( $id = false)
    {
        
        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Nuevo Slide'));
        $data = array(  

            'tipo'          => $this->tipo,
            'error'         => "",
            'msj'           => "",
            'send'          => false
        );

        $data['message'] = false;

        if($id != false)
        {   
            $data['message'] = $this->messagesmodel->message((int)$id);
        }
        
        if(isset($_POST["enviar"]))
        {

            if($this->form_validation->run($this->tipo))
            {

                $datos = array(

                    'to'            => $this->input->post('to'), 
                    'reply_to'      => $this->config->item('smtp_user'), 
                    'subject'       => $this->input->post('subject'),
                    'html'          => $this->input->post('text')

                    );
                
                if($this->functions->sendEmail($datos))
                {

                    $msg = array(

                        'date'          => date("Y-m-d H:i:s"),
                        'mail'          => $this->input->post('to'),
                        'message_id'    => $id == false ? 0 : $id,
                        'text'          => $this->input->post('text')

                        );

                    $this->messagesmodel->addResponse($msg);

                    $data['send'] = true;
                
                }
                else
                {
                    $data['error'] = array('error' => $this->upload->display_errors());
                }

            }
        }

        $accion = $data['send'] ? 'volver' : 'cancelar';

        $this->templates_admin->subMenu(array($accion => 'mensajes/listar' ));

        $this->templates_admin->sidebar();

        $this->load->view('admin/'.$this->tipo.'/nuevo', $data); 
            
        $this->templates_admin->footer();
    }

    

    

    

    

    

    

    /////////////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////SECCION DE FUNCIONES//////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////


      

    
    
    public function eliminar($id = null){
        
        if($id == false || !is_numeric($id)){

            redirect('admin/paginas/listar');
            exit();
        }
        
        $data['permisos']   = $this->permisos;
        $data['error']      = false;
        $data['titulo']     = ' | <span>Eliminar Pagina</span>';
        $this->load->view('admin/header',$data);

        $menu = array(
            'crear' => false,
            'paginador' => false,
            'cancelar' => false,
            'ordenar' => false
            );

        $this->load->view('admin/paginas/menu',$menu);
        
        //elimino el producto
        if($id != null){
            
            if($this->productosmodelo->eliminar_producto($id)){
                
                $this->load->view('admin/paginas/eliminar_exito');
            
            }else{
                
            }
            
        }else{
            
            show_404();
        }

        //cargo footer
        $this->load->view('admin/footer.php');
    }


    














}
?>