<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Metodos extends CI_Controller{


    public function __construct()
    {
        parent::__construct();

        $this->load->model('settingsmodel');
        $this->load->model('statusmodel');
        $this->load->model('metodosmodelo');

        $this->session->set_userdata('admin_menu', 'metodos');

        if( ! $this->statusmodel->loggedAdmin())
        {
            redirect('admin');
            exit();
        }
    }

    public function index()
    {
        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Lista de métodos de pago'));
        $this->templates_admin->sidebar();
        $this->templates_admin->subMenu(array(), false, true, 'metodos');
        
        $data = array(

            'metodos'    => $this->metodosmodelo->get(0, 90000, 'nombre DESC', false),

        );

        $this->load->view('admin/metodos/listar', $data);

        $this->templates_admin->footer();
    }

    public function nuevo()
    {

        $data = array(

            'id_metodo'     => null,
            'nombre'        => html_escape( $this->input->post('nombre', true) ),
            'descripcion'   => html_escape( $this->input->post('descripcion', true) ),
            'activo'        => 1,
        );

        if( $this->metodosmodelo->add($data) )
        {
            redirect('admin/metodos');
        }
        else
        {
            die('Se ha producido un error.');
        }

    }

    public function actualizar()
    {
        //var_dump($_POST);

        if( !empty($_POST) )
        {
            foreach ($_POST['id_metodo'] as $key => $id)
            {
                $data = array(

                    'nombre'        => html_escape( $_POST['nombre'][$key] ),
                    'descripcion'   => html_escape( $_POST['descripcion'][$key] ),
                    'activo'        => isset( $_POST['activo'][$key] ) ? 1 : 0
                );

                $this->metodosmodelo->update($id, $data);

            }
        }

        redirect('admin/metodos');
    }

    public function eliminar($id_metodo = false)
    {   

        if( !$id_metodo ) die();

        $this->metodosmodelo->delete($id_metodo);

        redirect('admin/metodos');
    }

}
?>