<?php

class Ofertasmodelo extends CI_Model{

	private $table_name = "ofertas";

    public function __construct()
    {
        parent::__construct();
    }


    public function get($start = 0, $results = 990000, $order = "fecha DESC", $active = true)
    {
        $sql_extra = "";

        if($active)
        {
            $sql_extra = " AND activo = 1 ";
        }

        $start = intval($start);

        $sql = "SELECT * FROM $this->table_name
                WHERE 1
                $sql_extra
                ORDER BY $order
                LIMIT $start, $results";

    	$query = $this->db->query($sql);

    	if($query->num_rows() > 0)
    	{
            $res = $query->result();

            return $res;
    	}

    	return false;
    }

    public function getActive($limit = 12)
    {
        $active = $this->get(0,$limit,'fecha DESC', true);

        return $active;

    }

    public function count($active = false)
    {
        $sql_extra = "";

        if($active)
        {
            $sql_extra = " AND active = 1 ";
        }

        $sql = "SELECT COUNT(*) FROM $this->table_name WHERE 1 ".$sql_extra;

        $res = $this->db->query($sql);

        return $res->row()->{'COUNT(*)'};
    }

    public function single($id = false)
    {
        $sql = "SELECT * FROM $this->table_name
                WHERE $this->table_name.id = $id
                LIMIT 0,1";

        $query = $this->db->query($sql);
        
        if($query->num_rows() == 1)
        {
            $oferta = $query->row();

            return $oferta;
        }

        return false;
    }

    public function add($data)
    {
        if($this->db->insert($this->table_name, $data))
        {
            return true;
        }

        return false;
    }

    public function lastId()
    {
        $sql = "SELECT id FROM $table_name
                ORDER BY id DESC
                LIMIT 1";

        $res = $this->db->query($sql);

        if($res->num_rows() == 1)
        {
            return $res->row()->id;
        }

        return false;
    }

    public function update($id = false, $data = array())
    {
        if( ! $id)
        {
            return false;
        }

        $this->db->where('id', $id);

        if($this->db->update($this->table_name, $data))
        {
            return true;
        }

        return false;
    }

    public function set_active($id, $active = false)
    {

        $a = $active == true ? 1 : 0;

        $sql = "UPDATE $this->table_name
                SET activo = $a
                WHERE id = $id";

        $this->db->query($sql);
    }

    public function desactivar_todo()
    {
        $sql = "UPDATE $this->table_name
                SET activo = 0";

        $this->db->query($sql);
    }

    public function delete($id)
    {
        $sql = "DELETE FROM $this->table_name
                WHERE id = $id";

        if($this->db->query($sql))
        {   
            return true;
        }

        return false;
    }


}