$(document).ready(function(){

    (function(){

        var Main = {

            build: function()
            {
                this.cambiarQty();

                this.agregarCarrito();

                this.login();

                this.register();

                this.modalVideo();

                this.cambiarQtyCarrito();

                this.agendarReunion();
            },

            initialize: function()
            {
                this.build();
            },

            agendarReunion: function()
            {

                $('#agendar-reunion').submit(function(event){

                    event.preventDefault();

                    var data = $(this).serialize();

                    $.ajax({

                        url: 'ajax/agendar',
                        method: 'POST',
                        dataType: 'json',
                        data: data,
                        success: function(data)
                        {
                            if( data.success ) 
                            {
                                $('#agendar-reunion').slideUp(function(){

                                    $('#agendar-reunion').html('<h3 style="color:whitesmoke">Formulario enviado con éxito</h3><p>Nos pondremos en contacto con usted a la brevedad, muchas gracias.</p>');
                                    $('#agendar-reunion').slideDown();

                                });
                            }
                            else
                            {
                                $('#agendar-feedback').html(data.text);
                            }
                        },
                        error: function()
                        {
                            alert('Se ha producido un error.');
                        }


                    })

                })

            },

            modalVideo: function()
            {

                $('.modal-video').click(function(event){

                    event.preventDefault();

                    var modal = $('#modal-video');

                    var src     = $(this).attr('data-src');
                    var titulo  = $(this).attr('data-titulo');

                    $('#iframe_video').attr('src', src);
                    $('#modal-titulo').html(titulo);

                    modal.modal().on('hide.bs.modal', function (e) {
                      
                        $('#iframe_video').attr('src', '');

                    });


                })

            },

            cambiarQtyCarrito: function()
            {
                $('.qty').change(function(event){

                    var rowid   = $(this).attr('data-rowid');
                    var qty     = $(this).val(); 

                    $.ajax({

                        type: "POST",
                        url: "carrito/update",
                        dataType: "json",
                        data: { rowid: rowid, qty: qty },
                        success: function( data )
                        {

                            if(data.success)
                            {
                                location.reload();   
                            }                            

                        }

                    });

                })
            },

            eliminarItemCarrito: function()
            {
                $(document).on('click', '.eliminar-item-carrito', function(event){

                    event.preventDefault();

                    var id          = $(this).attr('data-id');
                    var bloque      = $(this).parent().parent();

                    if(!id)
                    {
                        alert('Se ha producido un error!');
                        return;
                    }


                    $.ajax({
                        
                        type: "POST",
                        url: "ajax/actualizar_carrito",
                        dataType: "json",
                        data: { id: id },
                        success: function( data )
                        {

                            if(data.success)
                            {
                                Main.renderHeaderCarrito(true);
                            }
                            

                        }
                    });


                })
            },

            modalNoAutorizado: function()
            {
                $(document).on('click', '.link-modal-no-autorizado',function(event){

                    event.preventDefault();

                    $('#modal-no-autorizado').modal({
                    
                    })

                })

                $(document).on('click', '.cerrar-modal-no-autorizado',function(event){

                    event.preventDefault();

                    $('#modal-no-autorizado').modal('hide');


                })
            },

            agregarCarrito: function()
            {
                $(document).on('click', '.carrito', function(event){

                    event.preventDefault();

                    var _this   = $(this);
                    var _id     = $(this).attr('data-id');
                    var _qty    = $('#qty').val();

                    $.ajax({

                        url: 'carrito/add',
                        type: 'POST',
                        dataType: 'json',
                        data: {id: _id, qty: _qty},
                        success: function(data)
                        {
                            if(data.success)
                            {
                                Main.mostrarModalProducto(_id);
                            }
                            else
                            {
                               Main.modalError('Error al agregar al carrito.')
                            }


                        },
                        error: function(data)
                        {
                            Main.modalError('Se ha producido un error al agregar el producto al carrito, vuelva a intentarlo en otro momento.');
                        }

                    })

                })
            },

            cambiarQty: function()
            {
                $('.cambiar-qty').click(function(event){

                    event.preventDefault();

                    if( $(this).attr('data-type') == 'mas' )
                    {   
                        var v = parseInt( $('#qty').val() ) + 1;

                        $('#qty').val( v );

                        $('#qty_numero').html( v );
                    }     
                    else
                    {
                        if( $('#qty').val() > 1 )
                        {
                            var v = parseInt( $('#qty').val() ) - 1;

                            $('#qty').val( v );

                            $('#qty_numero').html( v );

                        }
                        
                    }

                    $('#boton-comprar').attr('data-qty', $('#qty').val());

                })
            },

            mostrarModalProducto: function(_id)
            {

                $.ajax({

                    url: 'ajax/modal_producto',
                    type: 'POST',
                    dataType: 'json',
                    data: {id: _id},
                    success: function(data)
                    {
                        if(data.success)
                        {

                            var modal_existente = $('#modal-producto');

                            if(modal_existente.length)
                            {
                                modal_existente.remove();
                            }

                            $('body').append(data.text);

                            $('#modal-producto').modal({}).one('hidden.bs.modal', function(){

                                Main.renderHeaderCarrito(false);

                            });
                        }
                        else
                        {

                        }

                    },
                    error: function(data)
                    {

                    }

                })
            },

            renderHeaderCarrito: function(mostrar)
            {

                $.ajax({

                    url: 'ajax/get_carrito_header',
                    type: 'POST',
                    dataType: 'text',
                    data: {mostrar: mostrar},
                    success: function(data)
                    {
                        $('#carrito').html(data);
                    },
                    error: function(data)
                    {
                        Main.modalError('Se ha producido un error al agregar el producto al carrito.');
                    }

                })
            },

            modalNotificacion: function(titulo, texto)
            {   
                $('#notificacion-titulo').html(titulo);
                $('#notificacion-texto').html(texto);
                $('#modal-notificacion').modal({});
            },

            modalError: function(text)
            {
                $('#error-text').html(text);
                $('#modal-error').modal({});
            },

            login: function()
            {

                $('#form-login').submit(function(event){

                    event.preventDefault();
                    
                    var user        = $('#email-login');
                    var pass        = $('#pass-login');
                    var recordar    = $('#recordar-login');
                    var error_div   = $('#error-div-login');

                    $.ajax({

                        type: "POST",
                        url: "ajax/access",
                        data: {user: user.val(), password: pass.val(), recordar: recordar.is(":checked")},
                        success: function(data)
                        {
                            if(data.success)
                            {
                                location.reload();
                            }
                            else
                            {
                                error_div.html(data.msg);
                            }

                        },
                        error : function()
                        {

                        },
                        dataType : 'json'
                    });

                })
            },

            register: function()
            {
                
                $('#form-register').submit(function(event){

                    event.preventDefault();

                    $('#body_registro').css('visibility', 'hidden');
                    $('.buscando-registro').css('visibility', 'visible');

                    var form        = $(this);
                    var formData    = $(this).serializeArray();
                    var feedback    = $('#feedback-register');

                    var errorDiv    = $('#error-div-register');
                    var boton       = $('#button-register');
                    var footer      = $('#footer_registro');

                    boton.prop('disabled', 'disabled');

                    $.ajax({

                        type: "POST",
                        url: "ajax/register_user",
                        data: formData,
                        success: function(data)
                        {
                        
                            if(data.success)
                            {   
                                feedback.html(data.msg);

                                form.parent().slideUp(function(){

                                    feedback.slideDown();

                                });
                            }
                            else
                            {
                                errorDiv.html(data.msg);
                                // clicked = false;
                                // $('#body_registro').css('visibility', 'visible');
                                // $('.buscando-registro').css('visibility', 'hidden');
                            }

                        },
                        error: function()
                        {
                            Main.modalError('Se ha producido un error inesperado, intentelo de nuevo mas tarde.')
                        },
                        complete: function()
                        {
                            boton.removeAttr('disabled');
                        },
                        dataType : 'json'
                    });
                })
            },

        }

        Main.initialize();

    })();

    var fotorama = $('.fotorama').data('fotorama');

    $(document).on('click', '.fotorama__stage__frame .fotorama__img', function(){

        fotorama.toggleFullScreen();

    })

    $('.abrir-sidebar').click(function(event){

        event.preventDefault();

        var ul = $(this).next();
        var i = $(this).find('i')

        if( ul.css('display') == 'none' )
        {
            ul.slideDown(function(){

                i.removeClass('fa-chevron-down');
                i.addClass('fa-chevron-up');
                
            });
        }
        else
        {
            ul.slideUp(function(){

                i.removeClass('fa-chevron-up');
                i.addClass('fa-chevron-down');
                
            });
        }


    })


    var tmp = $('#tmp_01');

    if( tmp.length )
    {
        tmp.parent().parent().parent().slideDown();
    }

    function a()
    {
        alert(isPlayerReady);

        if( !isPlayerReady )
        {
            setTimeout(a, 1000);
        }
    }

   // a();

    $(window).scroll(function() {

        var scroll = $(this).scrollTop();
        var header = $('.header-fixed');


        if( scroll > 300 )
        {
            header.addClass('gris');
        }
        else
        {
            header.removeClass('gris');
        }


        var v = $('#v');

        if( v.length )
        {
            var hT = v.offset().top,
            hH = $('#v').outerHeight(),
            wH = $(window).height(),
            wS = $(this).scrollTop();
            

           if (wS > (hT+hH-wH))
           {
               if( isPlayerReady )
               {
                    player.playVideo();
               }
           }
        }


    });


    $('#enviar').click(function(){

        $('#comments_form').submit();

    })
    
})